Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision 7b90778d6bd2bbdf6bb7c2d938d4519fdc30bbb9)
+++ kernel/arch/amd64/src/interrupt.c	(revision 750636ac4a65360c44846b7681af6ae46854dd3a)
@@ -66,27 +66,28 @@
 void istate_decode(istate_t *istate)
 {
-	printf("cs =%0#18" PRIx64 "\trip=%0#18" PRIx64 "\t"
-	    "rfl=%0#18" PRIx64 "\terr=%0#18" PRIx64 "\n",
-	    istate->cs, istate->rip, istate->rflags, istate->error_word);
+	printf("cs =%#0" PRIx64 "\trip=%p\t"
+	    "rfl=%#0" PRIx64 "\terr=%#0" PRIx64 "\n",
+	    istate->cs, (void *) istate->rip,
+	    istate->rflags, istate->error_word);
 	
 	if (istate_from_uspace(istate))
-		printf("ss =%0#18" PRIx64 "\n", istate->ss);
-	
-	printf("rax=%0#18" PRIx64 "\trbx=%0#18" PRIx64 "\t"
-	    "rcx=%0#18" PRIx64 "\trdx=%0#18" PRIx64 "\n",
+		printf("ss =%#0" PRIx64 "\n", istate->ss);
+	
+	printf("rax=%#0" PRIx64 "\trbx=%#0" PRIx64 "\t"
+	    "rcx=%#0" PRIx64 "\trdx=%#0" PRIx64 "\n",
 	    istate->rax, istate->rbx, istate->rcx, istate->rdx);
 	
-	printf("rsi=%0#18" PRIx64 "\trdi=%0#18" PRIx64 "\t"
-	    "rbp=%0#18" PRIx64 "\trsp=%0#18" PRIx64 "\n",
-	    istate->rsi, istate->rdi, istate->rbp,
-	    istate_from_uspace(istate) ? istate->rsp :
-	    (uintptr_t) &istate->rsp);
-	
-	printf("r8 =%0#18" PRIx64 "\tr9 =%0#18" PRIx64 "\t"
-	    "r10=%0#18" PRIx64 "\tr11=%0#18" PRIx64 "\n",
+	printf("rsi=%p\trdi=%p\trbp=%p\trsp=%p\n",
+	    (void *) istate->rsi, (void *) istate->rdi,
+	    (void *) istate->rbp,
+	    istate_from_uspace(istate) ? ((void *) istate->rsp) :
+	    &istate->rsp);
+	
+	printf("r8 =%#0" PRIx64 "\tr9 =%#0" PRIx64 "\t"
+	    "r10=%#0" PRIx64 "\tr11=%#0" PRIx64 "\n",
 	    istate->r8, istate->r9, istate->r10, istate->r11);
 	
-	printf("r12=%0#18" PRIx64 "\tr13=%0#18" PRIx64 "\t"
-	    "r14=%0#18" PRIx64 "\tr15=%0#18" PRIx64 "\n",
+	printf("r12=%#0" PRIx64 "\tr13=%#0" PRIx64 "\t"
+	    "r14=%#0" PRIx64 "\tr15=%#0" PRIx64 "\n",
 	    istate->r12, istate->r13, istate->r14, istate->r15);
 }
Index: kernel/arch/arm32/src/exception.c
===================================================================
--- kernel/arch/arm32/src/exception.c	(revision 7b90778d6bd2bbdf6bb7c2d938d4519fdc30bbb9)
+++ kernel/arch/arm32/src/exception.c	(revision 750636ac4a65360c44846b7681af6ae46854dd3a)
@@ -174,16 +174,17 @@
 void istate_decode(istate_t *istate)
 {
-	printf("r0 =%0#10" PRIx32 "\tr1 =%0#10" PRIx32 "\t"
-	    "r2 =%0#10" PRIx32 "\tr3 =%0#10" PRIx32 "\n",
+	printf("r0 =%#0" PRIx32 "\tr1 =%#0" PRIx32 "\t"
+	    "r2 =%#0" PRIx32 "\tr3 =%#0" PRIx32 "\n",
 	    istate->r0, istate->r1, istate->r2, istate->r3);
-	printf("r4 =%0#10" PRIx32 "\tr5 =%0#10" PRIx32 "\t"
-	    "r6 =%0#10" PRIx32 "\tr7 =%0#10" PRIx32 "\n",
+	printf("r4 =%#" PRIx32 "\tr5 =%#0" PRIx32 "\t"
+	    "r6 =%#0" PRIx32 "\tr7 =%#0" PRIx32 "\n",
 	    istate->r4, istate->r5, istate->r6, istate->r7);
-	printf("r8 =%0#10" PRIx32 "\tr9 =%0#10" PRIx32 "\t"
-	    "r10=%0#10" PRIx32 "\tfp =%0#10" PRIx32 "\n",
-	    istate->r8, istate->r9, istate->r10, istate->fp);
-	printf("r12=%0#10" PRIx32 "\tsp =%0#10" PRIx32 "\t"
-	    "lr =%0#10" PRIx32 "\tspsr=%0#10" PRIx32 "\n",
-	    istate->r12, istate->sp, istate->lr, istate->spsr);
+	printf("r8 =%#0" PRIx32 "\tr9 =%#0" PRIx32 "\t"
+	    "r10=%#0" PRIx32 "\tfp =%p\n",
+	    istate->r8, istate->r9, istate->r10,
+	    (void *) istate->fp);
+	printf("r12=%#0" PRIx32 "\tsp =%p\tlr =%p\tspsr=%p\n",
+	    istate->r12, (void *) istate->sp,
+	    (void *) istate->lr, (void *) istate->spsr);
 }
 
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision 7b90778d6bd2bbdf6bb7c2d938d4519fdc30bbb9)
+++ kernel/arch/ia32/Makefile.inc	(revision 750636ac4a65360c44846b7681af6ae46854dd3a)
@@ -35,5 +35,5 @@
 ENDIANESS = LE
 
-CMN1 = -m32 -fno-omit-frame-pointer
+CMN1 = -m32
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
Index: kernel/arch/ia32/src/interrupt.c
===================================================================
--- kernel/arch/ia32/src/interrupt.c	(revision 7b90778d6bd2bbdf6bb7c2d938d4519fdc30bbb9)
+++ kernel/arch/ia32/src/interrupt.c	(revision 750636ac4a65360c44846b7681af6ae46854dd3a)
@@ -66,24 +66,25 @@
 void istate_decode(istate_t *istate)
 {
-	printf("cs =%0#10" PRIx32 "\teip=%0#10" PRIx32 "\t"
-	    "efl=%0#10" PRIx32 "\terr=%0#10" PRIx32 "\n",
-	    istate->cs, istate->eip, istate->eflags, istate->error_word);
-	
-	printf("ds =%0#10" PRIx32 "\tes =%0#10" PRIx32 "\t"
-	    "fs =%0#10" PRIx32 "\tgs =%0#10" PRIx32 "\n",
+	printf("cs =%#0" PRIx32 "\teip=%p\t"
+	    "efl=%#0" PRIx32 "\terr=%#0" PRIx32 "\n",
+	    istate->cs, (void *) istate->eip,
+	    istate->eflags, istate->error_word);
+	
+	printf("ds =%#0" PRIx32 "\tes =%#0" PRIx32 "\t"
+	    "fs =%#0" PRIx32 "\tgs =%#0" PRIx32 "\n",
 	    istate->ds, istate->es, istate->fs, istate->gs);
 	
 	if (istate_from_uspace(istate))
-		printf("ss =%0#10" PRIx32 "\n", istate->ss);
-	
-	printf("eax=%0#10" PRIx32 "\tebx=%0#10" PRIx32 "\t"
-	    "ecx=%0#10" PRIx32 "\tedx=%0#10" PRIx32 "\n",
+		printf("ss =%#0" PRIx32 "\n", istate->ss);
+	
+	printf("eax=%#0" PRIx32 "\tebx=%#0" PRIx32 "\t"
+	    "ecx=%#0" PRIx32 "\tedx=%#0" PRIx32 "\n",
 	    istate->eax, istate->ebx, istate->ecx, istate->edx);
 	
-	printf("esi=%0#10" PRIx32 "\tedi=%0#10" PRIx32 "\t"
-	    "ebp=%0#10" PRIx32 "\tesp=%0#10" PRIx32 "\n",
-	    istate->esi, istate->edi, istate->ebp,
-	    istate_from_uspace(istate) ? istate->esp :
-	    (uintptr_t) &istate->esp);
+	printf("esi=%p\tedi=%p\tebp=%p\tesp=%p\n",
+	    (void *) istate->esi, (void *) istate->edi,
+	    (void *) istate->ebp,
+	    istate_from_uspace(istate) ? ((void *) istate->esp) :
+	    &istate->esp);
 }
 
Index: kernel/arch/mips32/src/exception.c
===================================================================
--- kernel/arch/mips32/src/exception.c	(revision 7b90778d6bd2bbdf6bb7c2d938d4519fdc30bbb9)
+++ kernel/arch/mips32/src/exception.c	(revision 750636ac4a65360c44846b7681af6ae46854dd3a)
@@ -74,7 +74,8 @@
 void istate_decode(istate_t *istate)
 {
-	printf("epc=%#010" PRIx32 "\tsta=%#010" PRIx32 "\t"
+	printf("epc=%p\tsta=%#010" PRIx32 "\t"
 	    "lo =%#010" PRIx32 "\thi =%#010" PRIx32 "\n",
-	    istate->epc, istate->status, istate->lo, istate->hi);
+	    (void *) istate->epc, istate->status,
+	    istate->lo, istate->hi);
 	
 	printf("a0 =%#010" PRIx32 "\ta1 =%#010" PRIx32 "\t"
@@ -106,7 +107,7 @@
 	    istate->s8, istate->at, istate->kt0, istate->kt1);
 	
-	printf("sp =%#010" PRIx32 "\tra =%#010" PRIx32 "\t"
-	    "gp =%#010" PRIx32 "\n",
-	    istate->sp, istate->ra, istate->gp);
+	printf("sp =%p\tra =%p\tgp =%p\n",
+	    (void *) istate->sp, (void *) istate->ra,
+	    (void *) istate->gp);
 }
 
Index: kernel/arch/ppc32/src/interrupt.c
===================================================================
--- kernel/arch/ppc32/src/interrupt.c	(revision 7b90778d6bd2bbdf6bb7c2d938d4519fdc30bbb9)
+++ kernel/arch/ppc32/src/interrupt.c	(revision 750636ac4a65360c44846b7681af6ae46854dd3a)
@@ -54,44 +54,44 @@
 void istate_decode(istate_t *istate)
 {
-	printf("r0 =%0#10" PRIx32 "\tr1 =%0#10" PRIx32 "\t"
-	    "r2 =%0#10" PRIx32 "\n", istate->r0, istate->sp, istate->r2);
+	printf("r0 =%#0" PRIx32 "\tr1 =%p\tr2 =%#0" PRIx32 "\n",
+	    istate->r0, (void *) istate->sp, istate->r2);
 	
-	printf("r3 =%0#10" PRIx32 "\tr4 =%0#10" PRIx32 "\t"
-	    "r5 =%0#10" PRIx32 "\n", istate->r3, istate->r4, istate->r5);
+	printf("r3 =%#0" PRIx32 "\tr4 =%#0" PRIx32 "\tr5 =%#0" PRIx32 "\n",
+	    istate->r3, istate->r4, istate->r5);
 	
-	printf("r6 =%0#10" PRIx32 "\tr7 =%0#10" PRIx32 "\t"
-	    "r8 =%0#10" PRIx32 "\n", istate->r6, istate->r7, istate->r8);
+	printf("r6 =%#0" PRIx32 "\tr7 =%#0" PRIx32 "\tr8 =%#0" PRIx32 "\n",
+	    istate->r6, istate->r7, istate->r8);
 	
-	printf("r9 =%0#10" PRIx32 "\tr10=%0#10" PRIx32 "\t"
-	    "r11=%0#10" PRIx32 "\n", istate->r9, istate->r10, istate->r11);
+	printf("r9 =%#0" PRIx32 "\tr10=%#0" PRIx32 "\tr11=%#0" PRIx32 "\n",
+	    istate->r9, istate->r10, istate->r11);
 	
-	printf("r12=%0#10" PRIx32 "\tr13=%0#10" PRIx32 "\t"
-	    "r14=%0#10" PRIx32 "\n", istate->r12, istate->r13, istate->r14);
+	printf("r12=%#0" PRIx32 "\tr13=%#0" PRIx32 "\tr14=%#0" PRIx32 "\n",
+	    istate->r12, istate->r13, istate->r14);
 	
-	printf("r15=%0#10" PRIx32 "\tr16=%0#10" PRIx32 "\t"
-	    "r17=%0#10" PRIx32 "\n", istate->r15, istate->r16, istate->r17);
+	printf("r15=%#0" PRIx32 "\tr16=%#0" PRIx32 "\tr17=%#0" PRIx32 "\n",
+	    istate->r15, istate->r16, istate->r17);
 	
-	printf("r18=%0#10" PRIx32 "\tr19=%0#10" PRIx32 "\t"
-	    "r20=%0#10" PRIx32 "\n", istate->r18, istate->r19, istate->r20);
+	printf("r18=%#0" PRIx32 "\tr19=%#0" PRIx32 "\tr20=%#0" PRIx32 "\n",
+	    istate->r18, istate->r19, istate->r20);
 	
-	printf("r21=%0#10" PRIx32 "\tr22=%0#10" PRIx32 "\t"
-	    "r23=%0#10" PRIx32 "\n", istate->r21, istate->r22, istate->r23);
+	printf("r21=%#0" PRIx32 "\tr22=%#0" PRIx32 "\tr23=%#0" PRIx32 "\n",
+	    istate->r21, istate->r22, istate->r23);
 	
-	printf("r24=%0#10" PRIx32 "\tr25=%0#10" PRIx32 "\t"
-	    "r26=%0#10" PRIx32 "\n", istate->r24, istate->r25, istate->r26);
+	printf("r24=%#0" PRIx32 "\tr25=%#0" PRIx32 "\tr26=%#0" PRIx32 "\n",
+	    istate->r24, istate->r25, istate->r26);
 	
-	printf("r27=%0#10" PRIx32 "\tr28=%0#10" PRIx32 "\t"
-	    "r29=%0#10" PRIx32 "\n", istate->r27, istate->r28, istate->r29);
+	printf("r27=%#0" PRIx32 "\tr28=%#0" PRIx32 "\tr29=%#0" PRIx32 "\n",
+	    istate->r27, istate->r28, istate->r29);
 	
-	printf("r30=%0#10" PRIx32 "\tr31=%0#10" PRIx32 "\n",
+	printf("r30=%#0" PRIx32 "\tr31=%#0" PRIx32 "\n",
 	    istate->r30, istate->r31);
 	
-	printf("cr =%0#10" PRIx32 "\tpc =%0#10" PRIx32 "\t"
-	    "lr =%0#10" PRIx32 "\n", istate->cr, istate->pc, istate->lr);
+	printf("cr =%#0" PRIx32 "\tpc =%p\tlr =%p\n",
+	    istate->cr, (void *) istate->pc, (void *) istate->lr);
 	
-	printf("ctr=%0#10" PRIx32 "\txer=%0#10" PRIx32 "\t"
-	    "dar=%0#10" PRIx32 "\n", istate->ctr, istate->xer, istate->dar);
+	printf("ctr=%#0" PRIx32 "\txer=%#0" PRIx32 "\tdar=%#0" PRIx32 "\n",
+	    istate->ctr, istate->xer, istate->dar);
 	
-	printf("srr1=%0#10" PRIx32 "\n", istate->srr1);
+	printf("srr1=%p\n", (void *) istate->srr1);
 }
 
Index: uspace/lib/c/arch/ia32/Makefile.common
===================================================================
--- uspace/lib/c/arch/ia32/Makefile.common	(revision 7b90778d6bd2bbdf6bb7c2d938d4519fdc30bbb9)
+++ uspace/lib/c/arch/ia32/Makefile.common	(revision 750636ac4a65360c44846b7681af6ae46854dd3a)
@@ -28,5 +28,5 @@
 
 CLANG_ARCH = i386
-GCC_CFLAGS += -march=pentium -fno-omit-frame-pointer
+GCC_CFLAGS += -march=pentium
 
 ENDIANESS = LE